!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: eigen_recipes.f
!-----------------------
 
      Subroutine Eigensys(red_color,eigen_val,nrows)
!**************************************************************************
!     This routine interfaces gencolor to the eigensystem routines
!     tred2 and tqli from Numerical Recipes.
!     Note : tred2 and tqli must be DOUBLE PRECISION versions.
!     Note : The Numerical Recipes routines are not supplied as part of
!            madgraph.  This interface is intended for users who already
!            have copies of tred2 and tqli and wish to use these routines.
!**************************************************************************
      implicit none

! Constants

      integer    maxgraphs
      parameter (maxgraphs=9999)
      integer    maxcolors
      parameter (maxcolors=1000)

! Arguments

      double precision  red_color(maxcolors,maxgraphs)
      double precision  eigen_val(maxcolors)
      integer nrows

! Local Variables

      double precision  offdiag(maxcolors)

!-----------
! Begin Code
!-----------


      call tred2(red_color,nrows, maxcolors,eigen_val,offdiag)
      call tqli(eigen_val,offdiag,nrows,maxcolors,red_color)

      end
